describe "MomentAgo", ->
  beforeEach ->
    Timecop.install()

  afterEach ->
    Timecop.returnToPresent()
    Timecop.uninstall()

  describe "As an extension", ->

    describe "with a good date", ->
      beforeEach ->
        @time = '1403895335338'
        @span = $("<span id='pizza' data-time=#{@time}>pizza</span>")

        Timecop.freeze(new Date(2014, 6, 10, 14, 54));
        $($('#jasmine_content')).append(@span);

      it "returns 13 days ago", ->
        expect(@span.text()).toEqual "pizza"
        $(@span).moment_ago()
        expect($(@span).text()).toEqual "13 days ago"

    describe "with a blank date", ->
      beforeEach ->
        @span = $("<span id='pizza'>pizza</span>")
        $($('#jasmine_content')).append(@span);

      it "does nothing", ->
        expect(@span.text()).toEqual "pizza"
        $(@span).moment_ago()
        expect($(@span).text()).toEqual "pizza"

    describe "with a future date", ->
      beforeEach ->
        @time = '1403895335338000'
        @span = $("<span id='pizza' data-time=#{@time}>pizza</span>")
        Timecop.freeze(new Date(2014, 6, 10, 14, 54));
        $($('#jasmine_content')).append(@span);

      it "returns a few seconds ago", ->
        expect(@span.text()).toEqual "pizza"
        $(@span).moment_ago()
        expect($(@span).text()).toEqual "a few seconds ago"

  describe "As a function", ->
    it "returns 13 days ago", ->
      Timecop.freeze(new Date(2014, 6, 10, 14, 54));
      time = '1403895335338'
      expect($($.moment_ago(time)).text()).toEqual "13 days ago"